; blackbelt+tune by gerliczer on 2016-01-16
; created with Csabo's Plus4IDE 1.70 &
; Frank A. Kingswood's AS65 1.42
; upload only to strictly CBM264 series related sites
; PAL&NTSC compatible program
 
	org $1001-2
	dw  $1001
	
	dw nextln,2016	; second word is line number
	db $9E
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
	include "belttdat.asm"

delay	lda #$f0	; waiting for
loop	cmp $ff1d	; rasterline $f0
	bne loop
wait	cmp $ff1d	; waiting to leave it
	beq wait
	rts		; ending ~1 frame delay

start	jsr $ff84	; KERNAL IOINIT
	jsr $ff81       ; KERNAL CINIT
	lda #$ff        ; moving cursor
	sta $ff0d       ; off screen
	sta $ff0c
	ldy #2          ; X-position
	ldx #1          ; Y-position
	clc             ; setting mode
	jsr $fff0       ; KERNAL PLOT
	jsr $ff4f       ; KERNAL PRIMM
	fcc 'GERLICZER HERE AGAIN.'
	db 0
	ldy #4
	ldx #4
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'LIKE A STARVING VULTURE CIRCLING'
	db 0
	ldy #3
	ldx #6
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'ABOVE THE HEAD OF  ITS PROSPECTIVE'
	db 0
	ldy #1
	ldx #8
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'PRAY, I AM READY TO SWOOP DOWN ON SOME'
	db 0
	ldy #2
	ldx #10
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'EFFORTLESS IMPROVEMENT POSSIBILITIES'
	db 0
	ldy #9
	ldx #12
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'FOR THE  LAZY SCENERS.'
	db 0
	ldy #3
	ldx #15
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'THANKS TO GEORGE PATSOS FOR SOURCE'
	db 0
	ldy #1
	ldx #17
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'MATERIALS, CSABO AND  F. KINGSWOOD FOR'
	db 0
	ldy #2
	ldx #19
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'DEVELOPMENT TOOLS,  GAIA AND ISTVANV'
	db 0
	ldy #3
	ldx #21
	clc
	jsr $fff0
	jsr $ff4f
	fcc 'FOR EMULATORS'
	db 0
	ldy #28
	ldx #23
	clc
	jsr $fff0
	jsr $ff4f
	fcc '2016-01-16'
	db 0
	ldy #2          ; two times by
	ldx #0          ; 256 times
busy	jsr delay       ; wait for the same raster line
	dex
	bne busy
	dey
	bne busy
	lda #$3b        ; graphic mode
	sta $ff06
	lda $ff07       ; multi-color mode
	and #$40
	ora #$18
	sta $ff07
	lda #$08        ; bitmap from $2000
	sta $ff12
	lda #$18        ; luma-chroma matrix from $1800
	sta $ff14
	lda #$71        ; background color
	sta $ff15
	lda #$06        ; full screen color for 11 bits & border
	sta $ff16
	sta $ff19
	lda #$fe        ; muting sound generators
	sta $ff0e
	sta $ff0f
	lda #3
	sta $ff10
	lda $ff12
	and #$fc
	ora #3
	sta $ff12
	lda #$28        ; turning on channel 2 at maximum volume
	sta $ff11
	lda $ff80       ; checking TV system
	bmi pal
	lda #lo(DUR_NTSC)	; if NTSC
	sta tvsys_+1		; modifing note duration table
	lda #hi(DUR_NTSC)
	sta tvsys_+2
pal	sei		; disabling interrupt
	asl $ff09	; clearing occasional interrupt
	lda #$f0	; setting raster interrupt
	sta $ff0b
	lda #2
	sta $ff0a
	jsr delay	; clearing occasional interrupt
	asl $ff09
	sta $ff3f	; paging ROM away
	lda #lo(pal)	; setting reset vector
	sta $fffc
	lda #hi(pal)
	sta $fffd
	lda #lo(irq)	; setting interrupt vector
	sta $fffe
	lda #hi(irq)
	sta $ffff
	cli		; enabling interrupt
	jmp *		; infinite loop

irq	asl $ff09	; acknowledging interrupt
	dec dur_+1	; decreasing duration counter
dur_	lda #1          ; checking if note ended
	beq chknote	; if ended, read next
	rti		; otherwise exiting irq handler
chknote	lda note_+1     ; checking if tune ended
	cmp #lo(NOTES_END)
	bne note_
	lda note_+2
	cmp #hi(NOTES_END)
	bne note_
	lda #$0		; if ended, turning sound off
	sta $ff11
	rti		; exiting irq handler
note_	lda NOTES	; reading next note
	pha
	inc note_+1	; advancing note pointer
	bne noteidx
	inc note_+2
noteidx	and #$f		; getting note frequency index
	asl a
	tax
	lda FRQ,x       ; setting new note pitch
	sta $ff0f
	inx
	lda FRQ,x
	sta $ff10
	pla		; getting note duration index
	lsr a
	lsr a
	lsr a
	lsr a
	tax
tvsys_	lda DUR_PAL,x	; setting new note duration
	beq chknote	; if duration 0, read next note
	sta dur_+1
	rti
	
	
; additional files:
; belttdat.asm   song data source file (converted by George Patsos)
; bbeltgfx.prg   $1800-$3f3f gfx data (converted by George Patsos)

; linking:
; compile belttune.asm
; load the gfx file
; load belttune.prg
; s"blackbelt+tune",8,1001,3f40